Option Strict Off
Option Explicit On
Imports VB = Microsoft.VisualBasic
Friend Class frmMain
	Inherits System.Windows.Forms.Form
	'*********************************************************************************
	'   Revised 05-08-2007
	'
	'   ICS 4895 Keyboard Program is an interactive Keyboard Control program that
	'   demonstrates how to control ICS's 4895 Serial to GPIB Controller in Visual Basic
	'
	'   Copyright ICS Electronics 2007
	'********************************************************************************
	' 05-20-04  Changed device address to be a 2 or 4 char string
	'           Added pulldown to Command box
	' 01-27-05  Added timeouts to init command. Turned off ckauto for non-formatted cmds.
	' 02-02-05  Added NI Wrt-Rd commands for testing
	' 02-06-06  Added auto check when auto format for device is selected.
	' 05-08-07  Cleaned up with Microsoft Code Advisor
	'********************************************************************************
	'Public gCP             'COM Port selected 0=none
	Dim DevSet As Short '1 if user entered adevice address
	Public Addr As String 'GPIB device address
	Dim Instring As String 'reads 4895 responses
	Dim CmdLPFlg As Short 'enables timer to run command loop
	Dim LpCtr As Short 'counts number of completed command loops
	Dim RstTime As Short 'Reset flag
	Dim CmdStr As String 'command string
	Dim Dev As Short 'GPIB device address
	
	'UPGRADE_WARNING: Event optAutoFmt.CheckedChanged may fire when form is initialized. Click for more: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="88B12AE1-6DE0-48A0-86F1-60C0686C026A"'
	Private Sub optAutoFmt_CheckedChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles optAutoFmt.CheckedChanged
		If eventSender.Checked Then
			Dim index As Short = optAutoFmt.GetIndex(eventSender)
			Select Case index
				Case 0 'auto format
					'optAutoFmt(1).Value = 0
					'optAutoFmt(0).Value = 1
					ckAuto.CheckState = System.Windows.Forms.CheckState.Checked
					ckDispAll.CheckState = System.Windows.Forms.CheckState.Unchecked
				Case 1 'non formatted
					'optAutoFmt(0).Value = 0
					'optAutoFmt(1).Value = 1
					ckAuto.CheckState = System.Windows.Forms.CheckState.Unchecked
					ckDispAll.CheckState = System.Windows.Forms.CheckState.Checked
			End Select
		End If
	End Sub
	
	Private Sub cmdAbort_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdAbort.Click
		txtERROR.Visible = False
		RstTime = 0
		MSComm1.Output = "ABORT" & Chr(13)
		txtResp.Text = "IFC sent to all GPIB Devices"
		combCmd.Text = ""
	End Sub
	
	Private Sub cmdExit_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdExit.Click
		If gCP <> 0 Then MSComm1.PortOpen = False ' Close the serial port.
		End
	End Sub
	
	Private Sub cmdInit_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdInit.Click
		'Dim Instring As String
		Dim Buffer As String
		Dim Doctr As Integer
		
		txtERROR.Visible = False
		RstTime = 0
		Instring = ""
		MSComm1.InBufferCount = 0
		CmdStr = "ID" & Chr(13)
		MSComm1.Output = CmdStr
		' Wait for data to come back to the serial port.
		Buffer = ""
		Doctr = 0
		Do 
			System.Windows.Forms.Application.DoEvents()
			Buffer = Buffer & MSComm1.Input
			If Doctr > 20000 Then
				txtERROR.Text = "4895 not replying" 'error exit
				txtERROR.Visible = True
				Beep()
				txtResp.Text = "Bad response =" & Buffer
				GoTo initerr
			End If
			Doctr = Doctr + 1
		Loop Until InStr(Buffer, vbCrLf)
		Instring = Buffer
		Call Tdelay(0.1)
		Do While MSComm1.InBufferCount <> 0
			Buffer = ""
			Doctr = 0
			Do 
				System.Windows.Forms.Application.DoEvents()
				Buffer = Buffer & MSComm1.Input
				If Doctr > 20000 Then
					txtERROR.Text = "4895 not replying" 'error exit
					txtERROR.Visible = True
					Beep()
					txtResp.Text = "Bad response =" & Buffer
					GoTo initerr
				End If
				Doctr = Doctr + 1
			Loop Until InStr(Buffer, vbCrLf)
			Instring = Instring & Buffer
			Call Tdelay(0.1)
		Loop 
		If InStr(Instring, "4895") <> 0 Then 'verify 4895 replied
			txtERROR.Visible = False
			txtResp.Text = Instring
			MSComm1.Output = "CADDR 0" & Chr(13)
			txtCtlrAddr.Text = "0"
			Call Tdelay(0.1)
			MSComm1.Output = "END" & Chr(13)
			Call Tdelay(0.1)
			MSComm1.Output = "ABORT" & Chr(13)
			Call Tdelay(0.1)
			MSComm1.Output = "EOL R, X, 10" & Chr(13)
			cmdAbort.Enabled = True
			cmdRead.Enabled = True
			cmdReset.Enabled = True
			cmdSend.Enabled = True
			cmdSetCtlr.Enabled = True
			cmdSetDev.Enabled = True
			cmdStartLP.Enabled = True
			cmdStopLP.Enabled = True
			ckAuto.Enabled = True
			ckByteCnt.Enabled = True
			ckDispAll.Enabled = True
			optAutoFmt(0).Enabled = True
			optAutoFmt(1).Enabled = True
			optAutoFmt(1).Checked = 1
			ckNI.Enabled = True
			ckNI.CheckState = False
			txtResp.Text = "4895 initialized and set to address 0" & NL & "IFC sent to all devices"
		Else
			txtERROR.Text = "4895 Not responding - Reset4895 and try again"
			txtERROR.Visible = True
			txtResp.Text = Instring
			Beep()
		End If
		GoTo initexit
		
initerr: 
		MSComm1.Output = "@@@"
		txtResp.Text = txtResp.Text & NL & "4895 Reset - Wait 30 seconds and re-initialize"
initexit: 
	End Sub
	
	Private Sub cmdInitCP_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdInitCP.Click
		frmPorts.ShowDialog()
		If gCP <> 0 Then
			cmdInit.Enabled = True
			txtERROR.Visible = False
			' Notes from MS VB help
			' Buffer to hold input string
			' Dim Instring As String
			' MSComm1.CommPort = n
			' COM port selected on frmPorts
			' 9600 baud, no parity, 8 data, and 1 stop bit.
			' MSComm1.Settings = "9600,N,8,1"
			' Settings set on frmPorts
			' Tell the control to read entire buffer when Input
			' is used.
			MSComm1.InputLen = 0
			' Open the port.
			MSComm1.PortOpen = True
			' end the attention command to the modem.
			' MSComm1.Output = "ATV1Q0" & Chr$(13) ' Ensure that
			' the modem responds with "OK".
			' Wait for data to come back to the serial port.
			'Do
			'    DoEvents
			'   Buffer$ = Buffer$ & MSComm1.Input
			'Loop Until InStr(Buffer$, "OK" & vbCrLf)
			' Read the "OK" response data in the serial port.
			' Close the serial port.
			'MSComm1.PortOpen = False
		Else
			txtERROR.Text = "No COM Port Selected"
			Beep()
			txtERROR.Visible = True
		End If
		
	End Sub
	
	Private Sub cmdRead_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdRead.Click
        Dim Buffer As String = ""
		Dim Doctr As Integer
		Dim L As Short
		Dim DispBuffer As String
		Dim Nulls As Short
		
		txtERROR.Visible = False
		RstTime = 0
        If optAutoFmt(0).Checked = True Then    'auto formated read
            If ckNI.CheckState = 0 Then
                MSComm1.Output = "Enter " & Addr & Chr(13)
            Else
                MSComm1.Output = "RD #100 " & Addr & Chr(13)
            End If
            Buffer = ""
            Doctr = 0
            Do
                System.Windows.Forms.Application.DoEvents()
                Buffer = Buffer & MSComm1.Input
                If Doctr > 40000 Then   'hangup error exit
                    txtERROR.Text = "Program Timeout - 4895 not replying"
                    txtERROR.Visible = True
                    Beep()
                    txtResp.Text = "Bad response =" & Buffer
                    CmdLPFlg = 0        'stop any test loop
                    GoTo readexit
                End If
                Doctr = Doctr + 1
            Loop Until InStr(Buffer, vbLf) <> 0

            L = Len(Buffer)
            If (ckDispAll.CheckState = 0) And (ckNI.CheckState = 0) Then 'std read
                If InStr(Buffer, vbCr) <> 0 Then
                    Buffer = VB.Left(Buffer, InStr(Buffer, vbCr) - 1)
                ElseIf InStr(Buffer, vbLf) <> 0 Then
                    Buffer = VB.Left(Buffer, InStr(Buffer, vbLf) - 1)
                End If
            ElseIf ckNI.CheckState = 1 Then     'NI read byte count
                DispBuffer = VB.Left(Buffer, InStr(Buffer, vbLf)) 'saves response
                Buffer = ""
                Doctr = 0
                Do
                    System.Windows.Forms.Application.DoEvents()
                    Buffer = Buffer & MSComm1.Input
                    If Doctr > 40000 Then 'hangup error exit
                        txtERROR.Text = "Program Timeout - count missing"
                        txtERROR.Visible = True
                        Beep()
                        txtResp.Text = "Bad response =" & Buffer
                        CmdLPFlg = 0 'stop any test loop
                        GoTo readexit
                    End If
                    Doctr = Doctr + 1
                Loop Until InStr(Buffer, vbCrLf)
                If ckDispAll.CheckState = 0 Then
                    DispBuffer = VB.Left(DispBuffer, InStr(DispBuffer, vbLf) - 1) 'drop Lf
                Else
                    If InStr(Buffer, vbCr) <> 0 Then
                        Buffer = VB.Right(Buffer, 5)
                        Do
                            L = Len(Buffer)
                            Nulls = InStr(1, Buffer, Chr(0))
                            If Nulls > 0 Then Buffer = VB.Right(Buffer, L - 1)
                        Loop While Nulls
                    End If
                    DispBuffer = DispBuffer & NL & "Count= " & Buffer
                End If
                Buffer = DispBuffer
            End If
            txtResp.Text = Buffer
            If ckByteCnt.CheckState = 1 Then
                txtResp.Text = txtResp.Text & NL & "Count = " & Str(L)
            End If
        Else                                'non formatted read
            Do While MSComm1.InBufferCount <> 0
                Buffer = ""
                Doctr = 0
                Do
                    System.Windows.Forms.Application.DoEvents()
                    Buffer = Buffer & MSComm1.Input
                    If Doctr > 40000 Then
                        txtERROR.Text = "Program Timeout - 4895 not replying"
                        txtERROR.Visible = True
                        Beep()
                        txtResp.Text = "Bad response =" & Buffer
                        CmdLPFlg = 0    'stop any test loop
                        GoTo readexit   'error exit
                    End If
                    Doctr = Doctr + 1
                Loop Until InStr(Buffer, vbLf)
                Call Tdelay(0.1)
            Loop
            L = Len(Buffer)
            If L <> 0 Then
                'If ckDispAll.Value = 0 And optAutoFmt(0).Value = True Then
                If ckDispAll.CheckState = 0 Then
                    If InStr(Buffer, vbCr) <> 0 Then
                        Buffer = VB.Left(Buffer, InStr(Buffer, vbCr) - 1)
                    ElseIf InStr(Buffer, vbLf) <> 0 Then
                        Buffer = VB.Left(Buffer, InStr(Buffer, vbLf) - 1)
                    End If
                End If
                txtResp.Text = Buffer
            Else
                txtResp.Text = "Nothing in buffer"
            End If
            If ckByteCnt.CheckState = 1 Then
                txtResp.Text = txtResp.Text & NL & "Count = " & Str(L)
            End If
        End If
readexit: 
	End Sub
	
	Private Sub cmdReset_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdReset.Click
		If RstTime = 0 Then
			txtResp.Text = "The 4895 will have to be reeinitialized after this command"
			txtResp.Text = txtResp.Text & NL & "Press RESET again to continue"
			Beep()
			RstTime = 1
		Else
			MSComm1.Output = "@@@"
			RstTime = 0
			DevSet = 0
			txtDevAddr.Text = ""
			txtERROR.Visible = False
			ckAuto.CheckState = System.Windows.Forms.CheckState.Checked
			ckByteCnt.CheckState = System.Windows.Forms.CheckState.Unchecked
			ckDispAll.CheckState = System.Windows.Forms.CheckState.Unchecked
			optAutoFmt(0).Checked = 0
			optAutoFmt(1).Checked = 1
			ckAuto.Enabled = False
			ckByteCnt.Enabled = False
			ckDispAll.Enabled = False
			optAutoFmt(0).Enabled = False
			optAutoFmt(1).Enabled = False
			cmdExit.Enabled = True
			cmdInitCP.Enabled = True
			cmdInit.Enabled = True
			cmdAbort.Enabled = False
			cmdRead.Enabled = False
			cmdReset.Enabled = False
			cmdSDC.Enabled = False
			cmdSend.Enabled = False
			cmdSetCtlr.Enabled = False
			cmdSetDev.Enabled = False
			cmdSPOLL.Enabled = False
			cmdStartLP.Enabled = False
			cmdStopLP.Enabled = False
			cmdTrig.Enabled = False
			txtCtlrAddr.Text = "0"
			combCmd.Text = ""
			txtResp.Text = "Please wait - Resetting the 4895"
			txtResp.Refresh()
			Call Tdelay(10)
			txtResp.Text = "Reinitialize the 4895 now"
		End If
	End Sub
	
	Private Sub cmdSDC_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdSDC.Click
		txtERROR.Visible = False
		If DevSet = 1 Then
			MSComm1.Output = "CLEAR " & Addr & Chr(13)
			txtResp.Text = "Selected Device Clear sent to device " & Addr
			combCmd.Text = ""
		Else
			txtERROR.Text = "Device Address not set"
			txtERROR.Visible = True
			Beep()
		End If
	End Sub
	
	Private Sub cmdSend_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdSend.Click
		txtERROR.Visible = False
		RstTime = 0
		If optAutoFmt(0).Checked = True Then 'auto format
			If DevSet = 1 Then
				If ckNI.CheckState = False Then
					MSComm1.Output = "Output " & Addr & ";" & combCmd.Text & Chr(13)
				Else
					MSComm1.Output = "WRT " & Addr & Chr(13)
					MSComm1.Output = combCmd.Text & Chr(13)
				End If
				If ckAuto.CheckState = 1 Then
					If InStr(combCmd.Text, "?") <> 0 Then
						Call cmdRead_Click(cmdRead, New System.EventArgs())
					Else
						txtResp.Text = "Message sent to device " & Addr
					End If
				End If
			Else
				txtERROR.Text = "Device Address not set"
				txtERROR.Visible = True
				Beep()
				GoTo SendExit
			End If
		Else 'non formatted output
			MSComm1.Output = combCmd.Text & Chr(13)
			If ckAuto.CheckState = 1 Then
				combCmd.Text = UCase(combCmd.Text)
				If InStr(combCmd.Text, "ENTER") <> 0 Then
					Call cmdRead_Click(cmdRead, New System.EventArgs())
				End If
			Else
				txtResp.Text = "Message sent"
			End If
		End If
SendExit: 
	End Sub
	
	Private Sub cmdSetCtlr_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdSetCtlr.Click
		Dim Ctlr As Short
		
		txtERROR.Visible = False
		RstTime = 0
		Ctlr = Val(txtCtlrAddr.Text)
		MSComm1.Output = "CADDR " & Str(Ctlr) & Chr(13)
		txtResp.Text = "Controller address set to " & Str(Ctlr)
	End Sub
	
	Private Sub cmdSetDev_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdSetDev.Click
		txtERROR.Visible = False
		RstTime = 0
		Dev = Val(txtDevAddr.Text)
		If (Dev > 0 And Dev < 31) Or (Dev > 100 And Dev < 3131) Then
			DevSet = 1
			cmdSPOLL.Enabled = True
			cmdSDC.Enabled = True
			cmdTrig.Enabled = True
			optAutoFmt(0).Enabled = True
			optAutoFmt(1).Enabled = True
			optAutoFmt(0).Checked = 1
			ckAuto.CheckState = System.Windows.Forms.CheckState.Checked
			Addr = (txtDevAddr.Text)
			If Len(Addr) = 1 Then Addr = "0" & Addr
			If Len(Addr) = 3 Then Addr = "0" & Addr
			txtResp.Text = "Device address set to " & Addr
		Else
			txtERROR.Text = "Device Address out of range"
			txtERROR.Visible = True
			Beep()
		End If
	End Sub
	
	Private Sub cmdSPOLL_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdSPOLL.Click
		Dim Buffer As String
		
		txtERROR.Visible = False
		RstTime = 0
		If DevSet = 1 Then
			MSComm1.Output = "SPOLL " & Addr & Chr(13)
			Buffer = ""
			Do 
				System.Windows.Forms.Application.DoEvents()
				Buffer = Buffer & MSComm1.Input
			Loop Until InStr(Buffer, vbCrLf)
			txtResp.Text = "Device " & Addr & " Serial Poll Response = " & Buffer
			combCmd.Text = ""
		Else
			txtERROR.Text = "Device Address not set"
			txtERROR.Visible = True
			combCmd.Text = ""
			Beep()
		End If
	End Sub
	
	Private Sub cmdStartLP_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdStartLP.Click
		txtERROR.Visible = False
		RstTime = 0
		If Len(combCmd.Text) = 0 Then
			txtERROR.Text = "No command entered"
			txtERROR.Visible = True
			Beep()
		Else
			CmdLPFlg = 1
			LpCtr = 0
		End If
	End Sub
	
	Private Sub cmdStopLP_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdStopLP.Click
		CmdLPFlg = 0
		lblLPCtr.Visible = False
		txtLpCtr.Visible = False
	End Sub
	
	Private Sub cmdTrig_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdTrig.Click
		txtERROR.Visible = False
		RstTime = 0
		If DevSet = 1 Then
			MSComm1.Output = "Trigger " & Addr & Chr(13)
			txtResp.Text = "Trigger sent to device " & Addr
			combCmd.Text = ""
		Else
			txtERROR.Text = "Device Address not set"
			txtERROR.Visible = True
			Beep()
		End If
	End Sub
	
	Private Sub frmMain_Load(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles MyBase.Load
		Dim Rev As String
		
		gCP = 0
		NL = Chr(13) & Chr(10)
		RstTime = 0
		txtERROR.Visible = False
		Rev = "Revised 05-08-2007"
		txtRev.Text = Rev
		combCmd.Text = ""
		combCmd.Items.Insert(0, "*esr?")
		combCmd.Items.Insert(1, "*idn?")
		combCmd.Items.Insert(2, "*stb?")
		ckAuto.CheckState = System.Windows.Forms.CheckState.Unchecked
		ckByteCnt.CheckState = System.Windows.Forms.CheckState.Unchecked
		ckDispAll.CheckState = System.Windows.Forms.CheckState.Unchecked
		optAutoFmt(0).Checked = 0
		optAutoFmt(1).Checked = 0
		ckAuto.Enabled = False
		ckByteCnt.Enabled = False
		ckNI.Enabled = False
		ckDispAll.Enabled = False
		optAutoFmt(0).Enabled = False
		optAutoFmt(1).Enabled = False
		
		cmdExit.Enabled = True
		cmdInitCP.Enabled = True
		cmdInit.Enabled = False
		cmdAbort.Enabled = False
		cmdRead.Enabled = False
		cmdReset.Enabled = False
		cmdSDC.Enabled = False
		cmdSend.Enabled = False
		cmdSetCtlr.Enabled = False
		cmdSetDev.Enabled = False
		cmdSPOLL.Enabled = False
		cmdStartLP.Enabled = False
		cmdStopLP.Enabled = False
		cmdTrig.Enabled = False
		txtCtlrAddr.Text = "0"
		frmPorts.Hide()
	End Sub
	
	Private Sub Timer1_Tick(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Timer1.Tick
		If CmdLPFlg = 1 Then
			lblLPCtr.Visible = True
			txtLpCtr.Visible = True
			Call cmdSend_Click(cmdSend, New System.EventArgs())
			LpCtr = LpCtr + 1
			txtLpCtr.Text = CStr(LpCtr)
		End If
	End Sub

    Private Sub MSComm1_OnComm(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MSComm1.OnComm

    End Sub
End Class